"use client";
"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RefreshResult = exports.ClientCacheState = exports.OverrideBehaviour = exports.User = exports.SettingKeyValue = exports.SegmentComparator = exports.PrerequisiteFlagComparator = exports.UserComparator = exports.SettingType = exports.FormattableLogMessage = exports.LogLevel = exports.DataGovernance = exports.PollingMode = exports.withConfigCatClient = exports.useConfigCatClient = exports.useFeatureFlag = exports.ConfigCatProvider = exports.createFlagOverridesFromQueryParams = exports.createFlagOverridesFromMap = exports.createConsoleLogger = void 0;
var ConfigCatHOC_1 = __importDefault(require("./ConfigCatHOC"));
exports.withConfigCatClient = ConfigCatHOC_1.default;
var ConfigCatHooks_1 = require("./ConfigCatHooks");
Object.defineProperty(exports, "useConfigCatClient", { enumerable: true, get: function () { return ConfigCatHooks_1.useConfigCatClient; } });
Object.defineProperty(exports, "useFeatureFlag", { enumerable: true, get: function () { return ConfigCatHooks_1.useFeatureFlag; } });
var ConfigCatProvider_1 = __importDefault(require("./ConfigCatProvider"));
exports.ConfigCatProvider = ConfigCatProvider_1.default;
var FlagOverrides_1 = require("./FlagOverrides");
var configcat_common_1 = require("configcat-common");
Object.defineProperty(exports, "createConsoleLogger", { enumerable: true, get: function () { return configcat_common_1.createConsoleLogger; } });
Object.defineProperty(exports, "createFlagOverridesFromMap", { enumerable: true, get: function () { return configcat_common_1.createFlagOverridesFromMap; } });
/**
 * Creates an instance of `FlagOverrides` that uses query string parameters as data source.
 * @param behaviour The override behaviour.
 * Specifies whether the local values should override the remote values
 * or local values should only be used when a remote value doesn't exist
 * or the local values should be used only.
 * @param watchChanges If set to `true`, the query string will be tracked for changes.
 * @param paramPrefix The parameter name prefix used to indicate which query string parameters
 * specify feature flag override values. Parameters whose name doesn't start with the
 * prefix will be ignored. Defaults to `cc-`.
 * @param queryStringProvider The provider object used to obtain the query string.
 * Defaults to a provider that returns the value of `window.location.search`.
 */
function createFlagOverridesFromQueryParams(behaviour, watchChanges, paramPrefix, queryStringProvider) {
    return new FlagOverrides_1.flagOverridesConstructor(new FlagOverrides_1.QueryParamsOverrideDataSource(watchChanges, paramPrefix, queryStringProvider), behaviour);
}
exports.createFlagOverridesFromQueryParams = createFlagOverridesFromQueryParams;
/* Public types re-export from common-js */
// These exports should be kept in sync with the exports listed in the section "Public types for end users" of common-js/src/index.ts!
var configcat_common_2 = require("configcat-common");
Object.defineProperty(exports, "PollingMode", { enumerable: true, get: function () { return configcat_common_2.PollingMode; } });
var configcat_common_3 = require("configcat-common");
Object.defineProperty(exports, "DataGovernance", { enumerable: true, get: function () { return configcat_common_3.DataGovernance; } });
var configcat_common_4 = require("configcat-common");
Object.defineProperty(exports, "LogLevel", { enumerable: true, get: function () { return configcat_common_4.LogLevel; } });
var configcat_common_5 = require("configcat-common");
Object.defineProperty(exports, "FormattableLogMessage", { enumerable: true, get: function () { return configcat_common_5.FormattableLogMessage; } });
var configcat_common_6 = require("configcat-common");
Object.defineProperty(exports, "SettingType", { enumerable: true, get: function () { return configcat_common_6.SettingType; } });
Object.defineProperty(exports, "UserComparator", { enumerable: true, get: function () { return configcat_common_6.UserComparator; } });
Object.defineProperty(exports, "PrerequisiteFlagComparator", { enumerable: true, get: function () { return configcat_common_6.PrerequisiteFlagComparator; } });
Object.defineProperty(exports, "SegmentComparator", { enumerable: true, get: function () { return configcat_common_6.SegmentComparator; } });
var configcat_common_7 = require("configcat-common");
Object.defineProperty(exports, "SettingKeyValue", { enumerable: true, get: function () { return configcat_common_7.SettingKeyValue; } });
var configcat_common_8 = require("configcat-common");
Object.defineProperty(exports, "User", { enumerable: true, get: function () { return configcat_common_8.User; } });
var configcat_common_9 = require("configcat-common");
Object.defineProperty(exports, "OverrideBehaviour", { enumerable: true, get: function () { return configcat_common_9.OverrideBehaviour; } });
var configcat_common_10 = require("configcat-common");
Object.defineProperty(exports, "ClientCacheState", { enumerable: true, get: function () { return configcat_common_10.ClientCacheState; } });
Object.defineProperty(exports, "RefreshResult", { enumerable: true, get: function () { return configcat_common_10.RefreshResult; } });
