import type { IConfigCatClient, SettingTypeOf, SettingValue, User } from "configcat-common";
import React from "react";
export type GetValueType = <T extends SettingValue>(key: string, defaultValue: T, user?: User) => Promise<SettingTypeOf<T>>;
export interface WithConfigCatClientProps {
    configCatClient: IConfigCatClient;
    getValue: GetValueType;
    lastUpdated?: Date;
}
declare function withConfigCatClient<P>(WrappedComponent: React.ComponentType<P & WithConfigCatClientProps>, providerId?: string): React.ComponentType<Omit<P, keyof WithConfigCatClientProps>>;
export default withConfigCatClient;
//# sourceMappingURL=ConfigCatHOC.d.ts.map